import java.awt.*;

public class Gitter implements Parameter {
  // Gitter = Zellular-Raum
  
  Graphics g;

  private int[][] zustand;

  public Gitter (Graphics g0)
    {g = g0; zustand = new int[N][N];}

  public Gitter (Graphics g0, int[][] z0)
    {g = g0; zustand = z0;}

  public void Pentomino1() {
    // Pentomino als Anfangsfigur
    int i = N/2;
    zustand[i][i-2] = lebend;
    zustand[i][i-1] = lebend;
    zustand[i][i]   = lebend;
    zustand[i][i+1] = lebend;
    zustand[i][i+2] = lebend;
    } // Ende Pentomino1

  public void Gleiter() {
    // Gleiter als Anfangsfigur
    int i = N/5;
    zustand[i][i-1]   = lebend;
    zustand[i][i]     = lebend;
    zustand[i][i+1]   = lebend;
    zustand[i-1][i+1] = lebend;
    zustand[i-2][i]   = lebend;
    } // Ende Gleiter

  public void Pentomino2() {
    // R-Pentomino
    int i = N/3;
    zustand[i][i-1]   = lebend;
    zustand[i][i]     = lebend;
    zustand[i][i+1]   = lebend;
    zustand[i-1][i+1] = lebend;
    zustand[i+1][i]   = lebend;
    } // Ende Pentomino2

  public void Siebenerreihe() {
    // Sieben in einer Reihe
    int i = N/2, j = N/2;
    zustand[i][j-3] = lebend;
    zustand[i][j-2] = lebend;
    zustand[i][j-1] = lebend;
    zustand[i][j]   = lebend;
    zustand[i][j+1] = lebend;
    zustand[i][j+2] = lebend;
    zustand[i][j+3] = lebend;
    } // Ende Siebenerreihe

  public void Raumschiff() {
    // Leichtes Raumschiff
    int i = N/2, j = N/5;
    zustand[i-1][j-2] = lebend;
    zustand[i][j-1]   = lebend;
    zustand[i][j]     = lebend;
    zustand[i][j+1]   = lebend;
    zustand[i][j+2]   = lebend;
    zustand[i-1][j+2] = lebend;
    zustand[i-2][j+2] = lebend;
    zustand[i-3][j+1] = lebend;
    } // Ende Raumschiff

  private int AnzahlLebender (int i, int j) {
    // zhlt Anzahl der lebenden Nachbarn
    return zustand[i-1][j-1] + zustand[i-1][j] +
           zustand[i-1][j+1] + zustand[i][j+1] +
           zustand[i+1][j+1] + zustand[i+1][j] +
           zustand[i+1][j-1] + zustand[i][j-1];
    } // Ende AnzahlLebender

  public Gitter bergang (Graphics g) {
    int[][] zustandNeu = new int[N][N];
    for (int i = 1; i < N - 1; i++)
      for (int j = 1; j < N - 1; j++)
        if (zustand[i][j] == tot) {
          if (AnzahlLebender(i, j) == 3)
            zustandNeu[i][j] = lebend;
          } // Ende if
        else { // Zelle(i, j) lebt
          if (AnzahlLebender(i, j) > 3 || 
              AnzahlLebender(i, j) < 2)
            zustandNeu[i][j] = tot;
          else
            zustandNeu[i][j] = lebend;
          } // Ende else
    return new Gitter(g, zustandNeu);
    } // Ende bergang

  public int Zustand (int zeile, int spalte)
    {return zustand[zeile][spalte];}

  private void setzPunkt (int zeile, int spalte) {
    if (zustand[zeile][spalte] == lebend)
      g.setColor(Color.black);
    else
      g.setColor(Color.white);
    g.fillOval(spalte * feldbreite, zeile * feldbreite,
               feldbreite, feldbreite);
    } // Ende setzPunkt

  public void Ausgabe() {
    for (int i = 0; i < N; i++)
      for (int j = 0; j < N; j++)
        setzPunkt(i, j);
    } // Ende Ausgabe

  public void warte (int zeitdauer) {
    try {Thread.sleep(zeitdauer);}
    catch(InterruptedException e) {}
    } // Ende warte

  } // Ende Gitter
